#include <stdlib.h>
#include <arch.h>
#include <dbgmem.h>

#include "vector.h"
#include "fastmem.h"

size_t objsize[3] =
{ 
  sizeof(ZFlatPoly),
  sizeof(ZGoroudPoly),
  sizeof(ZTexturePoly)
};

struct MemBlock *Head[3]={0,0,0};

void *MemGet(enum memtype type)
{
  struct MemBlock *ptr;
  if (Head[type]!=0) {
    ptr=Head[type];
    Head[type]=ptr->next;
    return ((unsigned char *)ptr)+sizeof(struct MemBlock);
  } else {
    ptr=malloc(objsize[type]+sizeof(struct MemBlock));
    if (ptr)
      return ((unsigned char *)ptr)+sizeof(struct MemBlock);
    else 
      return 0;
  }
}

void MemLeave(void *vptr,enum memtype type)
{
  struct MemBlock *ptr;
  ptr=(struct MemBlock *) vptr - 1;
  ptr->next=Head[type];
  Head[type]=ptr;
}


