#ifndef DBGMEM_H
#define DBGMEM_H

#include <sys/types.h>

#ifndef INDBGMEM_C
#ifdef MEM_DEBUG
#define malloc(size) DbgMalloc(size,__FILE__,__LINE__)
#define free(ptr) DbgFree(ptr,__FILE__,__LINE__)
#define calloc(size) DbgCalloc(size,__FILE__,__LINE__)
#define cfree(ptr) DbgFree(ptr,__FILE__,__LINE__)
#define realloc(ptr,size) DbgReAlloc(ptr,size,__FILE__,__LINE__)
#endif
#endif

extern void *DbgMalloc(size_t size,char *file,int line);
extern void *DbgCalloc(size_t size,char *file,int line);
extern void DbgFree(void *ptr,char *file,int line);
extern void *DbgReAlloc(void *ptr,size_t size,char *file,int line);

extern void DbgMemStat(void);
#endif /* DBGMEM_H */
