#ifndef OBJECT_H
#define OBJECT_H

#include <zobject.h>

#define MAXVERTICES 4000
#define MAXPOLYGONS 4000

#define MAXVERTINPOLY 10

enum PolyType {
  POLY_FLAT,
  POLY_GOROUD,
  POLY_TEXTURE
};

typedef struct Polygon {
  enum PolyType Type;
  byte Color;
  int NumVertices;
  int Vertex[MAXVERTINPOLY];
  vector Normal;
  real UV[MAXVERTINPOLY*2]; /* is integer<<12 */
  byte *Texture;
  int BitWidth;
  byte BackFaceCulled;
} Polygon;

typedef struct ObjectDesc {
  real Radius;

  int NumVertices;
  vector *Vertex; 
  vector *VertexNormal; 

  int NumPolys;
  Polygon *Poly;

} ObjectDesc; 

enum ObjectType {
 OBJ_CONTAINER,
 OBJ_PRIMITIVE
};

typedef struct Object {
  enum ObjectType Type;
  matrix LocalTransform;
  matrix WorldTransform; /* Modified by the render */
  struct Object *next;
  struct Object *modifynext;  /* Modified by the render */
  union {
    struct {
      int NumObjects;
      int ModifyNumObjects;  /* Modified by the render */
      struct Object *Object[5];
      struct Object *ModifyObject[5];  /* Modified by the render */
    } Container;
    struct {
      ObjectDesc *Desc;
    } Primitive;
  } U;
} Object;

#endif /*OBJECT_H*/
